import requests
import argparse
import random
from urllib.parse import urlencode

if __name__ == "__main__":
    parser = argparse.ArgumentParser(
        prog="API Key Generator", description="Generate API Key for User"
    )

    parser.add_argument("--host")
    parser.add_argument("--user")
    parser.add_argument("--password")
    parser.add_argument("--scopes")

    args = parser.parse_args()

    s = requests.Session()

    login_data = {"email": args.user, "password": args.password}

    # Login using the service user
    response = s.post(
        url=f"{args.host}/hopsworks-api/api/auth/service",
        data={"email": args.user, "password": args.password},
    )

    params = {"name": f"hops_rm_{random.randint(0, 100)}", "scope": args.scopes}
    encoded_params = urlencode(params)

    response = s.post(
        url=f"{args.host}/hopsworks-api/api/users/apiKey?{encoded_params}",
        headers={"Authorization": response.headers["Authorization"]},
    )

    print(response.json()["key"])
